import java.util.Random;

/**
 * Die Klasse Puzzle.
 * 
 * @author (claus albowski) 
 * @version (9'19)
 */
public class Puzzle
{

    private int[][] ziel, feld;
    private Random r = new Random();

    /**
     * Konstruktor für Objekte der Klasse Puzzle
     */
    public Puzzle()
    {
        ziel = new int[3][3];
        feld = new int[3][3];
        for (int i=0;i<8;i++) ziel[i/3][i%3]=i+1;
        ziel[2][2]=0;
        mische();
    }

    public int[][] gibFeld() { return feld; }
    
    
    
    /**
     * Hilfsfunktion fuer mische
     */
    private int[] koordinatenNull() {
        int[] koordinaten = {9,9}; // unzulaessige Vorgabe nur fuer Compiler
        for (int z=0;z<3;z++)
        for (int s=0;s<3;s++)
        if (feld[z][s]==0) {
            koordinaten[0] = z;
            koordinaten[1] = s;
            break;
        }
        return koordinaten;
    }

    /**
     * Hilfsfunktion fuer mische
     * zeile und spalte vom angeklickten Feld, z und s von der 0
     */
    private void tausche(int zeile,int spalte,int z,int s){
        feld[z][s]=feld[zeile][spalte];
        feld[zeile][spalte]=0;
    }
    
    /**
     * mische
     * erzeugt den Anfangszustand des Felds
     * Das Problem ist:
     * Nicht alle zufaelligen Belegungen sind zulaessig.
     * Daher muss der Anfangszustand durch zulaessige Verschiebungen
     * erzeugt werden. 
     */
    public void mische() {
        for (int z=0;z<3;z++)
        for (int s=0;s<3;s++)
        feld[z][s]=ziel[z][s];
        int zeile,spalte;
        int[] koNull;
        for (int i=0;i<1000;i++) {
            zeile=Math.abs(r.nextInt())%3;
            spalte=Math.abs(r.nextInt())%3;
            koNull=koordinatenNull();
            //System.out.println(""+zeile+"/"+spalte+" "+koNull[0]+"/"+koNull[1]);
            if (Math.abs(zeile-koNull[0])+Math.abs(spalte-koNull[1])==1) // zulaessig?
            tausche(zeile,spalte,koNull[0],koNull[1]);
        }
    }
    
    /**
     * Zufallszahlengenerator setzen
     */
    public void setzeZufallszahlengenerator(long start) {
        if (start==0) r = new Random();
        else r = new Random(start);
    }
    
    /**
     * setze
     * Methode wird nur fuer zulaessige aufgerufen
     */
    public void  setze(int[] alt, int[] neu) {
        feld[neu[0]][neu[1]]=feld[alt[0]][alt[1]];
        feld[alt[0]][alt[1]]=0;
        //zeigeFeld();
    }

    /**
     * istFertig
     * prueft, ob der Zielzustand erreicht ist
     */
    public boolean istFertig() {
        if (!(feld[0][0]==1)) return false;
        else if (!(feld[0][1]==2)) return false;
        else if (!(feld[0][2]==3)) return false;
        else if (!(feld[1][0]==4)) return false;
        else if (!(feld[1][1]==5)) return false;
        else if (!(feld[1][2]==6)) return false;
        else if (!(feld[2][0]==7)) return false;
        else if (!(feld[2][1]==8)) return false;
        else if (!(feld[2][2]==0)) return false;
        else return true;
    }

    public void zeigeFeld() {
        for (int z=0;z<3;z++)
        System.out.println(feld[z][0]+" "+feld[z][1]+" "+feld[z][2]); 
        System.out.println(""); 
    }
}
